//
// Copyright (C) 1996 Ben Ross
//
// You may distribute under the terms of the GNU General Public
// License as specified in the COPYING file.
//

// $Id: XeFontTable.h,v 1.2 2001/08/01 11:22:25 ben Exp $

#ifndef _XeFontTable_H_
#define _XeFontTable_H_

#include <Xe.h>
#include <X11/Xlib.h>

#include <ext/hash_map>

// hash function object for std::string - maybe move this to Xe.h if it
// turns out that string keyed hash_maps are used elsewhere

namespace std
{
template<> struct hash<string>
{
    size_t  operator()(const string& s) const
    {
	return __stl_hash_string(s.c_str());
    }
};
}

class XeFontTable : public std::hash_map<std::string, XFontStruct*> {
public:
    XeFontTable(void)
	: std::hash_map<std::string, XFontStruct*>(64) {}
    ~XeFontTable();
        
    XFontStruct*	getFont(const char* fontname);
};

#endif // _XeFontTable_H_
